% Code for Bonhomme and Weidner (2021), "Minimizing Sensitivity to Model Misspecification"
% Likelihood for random-effects estimation in "Code_Probit_PanelData"

function obj = proc_lik_RE_corr(par,N,T,Sa,Y,UU)

alphagrid0=par(2)+exp(par(4))*norminv(UU);
alphagrid1=par(2)+par(3)+exp(par(4))*norminv(UU);

lik0=ones(N,Sa);
for tt=2:T+1
    lik0=lik0.*((Y(:,tt)==1).*normcdf(par(1)*Y(:,tt-1)+alphagrid0')+...
        (Y(:,tt)==0).*normcdf(-par(1)*Y(:,tt-1)-alphagrid0'));
end

loglik0=log(mean(lik0'))';

lik1=ones(N,Sa);
for tt=2:T+1
    lik1=lik1.*((Y(:,tt)==1).*normcdf(par(1)*Y(:,tt-1)+alphagrid1')+...
        (Y(:,tt)==0).*normcdf(-par(1)*Y(:,tt-1)-alphagrid1'));
end

loglik1=log(mean(lik1'))';

loglik=(1-Y(:,1)).*loglik0+Y(:,1).*loglik1;

obj=-mean(loglik);
end
